#ifndef DualMC33926_h
#define DualMC33926_h

#include <Arduino.h>

//#ifdef __SAM3X8E__  //DUE
// #undef PWM_FREQUENCY
 //#define PWM_FREQUENCY 20000 //20khz
//#endif
class DualMC33926
{
  public:  
    // CONSTRUCTORS
    DualMC33926(); // Default pin selection.
    DualMC33926(unsigned char M1DIR, unsigned char M1PWM, unsigned char M1FB,
                           unsigned char M2DIR, unsigned char M2PWM, unsigned char M2FB,
                           unsigned char nD2, unsigned char nSF); // User-defined pin selection. 
    
    // PUBLIC METHODS
    void init(); // Initialize TIMER 1, set the PWM to 20kHZ. 
    void restart();
    void setTorque(bool t);
    unsigned char getTorque();
    void setM1Speed(int speed); // Set speed for M1.
    void setM2Speed(int speed); // Set speed for M2.
    void setSpeeds(int m1Speed, int m2Speed); // Set speed for both M1 and M2.
    float getM1CurrentMilliamps(); // Get current reading for M1. 
    float getM2CurrentMilliamps(); // Get current reading for M2.
    unsigned char getFault(); // Get fault reading.
    
  private:
    unsigned char _nD2;
    unsigned char _M1DIR;
    unsigned char _M2DIR;
    unsigned char _M1PWM;
    unsigned char _M2PWM;
    unsigned char _nSF;
    unsigned char _M1FB;
    unsigned char _M2FB;
};

#endif
